/*
 * sos/sos.c --
 *
 *	There should be a compiler appreciation day. This file
 *	demonstrates why. Compile with and without optimization,
 *	look at the generated assembly code, play with it (e.g.,
 *	remove the static keywords, what does change?).
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

#if 0
#define static
#endif

static int64_t sos(int64_t a, int64_t b)
{
    int64_t i, s = 0, n = b-a+1;
    int64_t *p;
    
    if (n < 0) {
	return 0;
    }
    
    p = malloc(n * sizeof(int64_t));
    if (! p) {
	exit(1);
    }
    
    for (i = 0; i < n; i++) {
	p[i] = i+1;
    }
    
    for (i = 0; i < n; i++) {
	p[i] = p[i] * p[i];
    }
    
    for (i = 0; i < n; i++) {
	s += p[i];
    }
    
    free(p);
    return s;
}

static int64_t sos_(int64_t a, int64_t b)
{
    return (a > b) ? 0 : a*a + sos_(a+1, b);
}

static int64_t sosh(int64_t a, int64_t b, int64_t c)
{
    return (a > b) ? c : sosh(a+1, b, c+a*a);
}

static int64_t sos__(int64_t a, int64_t b)
{
    return sosh(a, b, 0);
}

static int64_t sos___(int64_t a, int64_t b)
{
    int64_t s = 0;
    for (s = 0; a <= b; a++) {
	s += a*a;
    }
    return s;
}

int main()
{
    int64_t a = 1, b = 4;
    // int64_t a = 1, b = 4444444;
    
    printf("sos %lld %lld = %lld\n", a, b, sos(a, b));
    printf("sos_ %lld %lld = %lld\n", a, b, sos_(a, b));
    printf("sos__ %lld %lld = %lld\n", a, b, sos__(a, b));
    printf("sos___ %lld %lld = %lld\n", a, b, sos___(a, b));
    
    return 0;
}
